#include <octave/config.h>



#include <cassert>

#include <csignal>

#include <cstdlib>

#include <cstring>

#include <ctime>



#include <fstream.h>

#include <iostream.h>

#include <strstream.h>



#ifdef HAVE_UNISTD_H

#ifdef HAVE_SYS_TYPES_H

#include <sys/types.h>

#endif

#include <unistd.h>

#endif



#ifdef HAVE_PWD_H

#include <pwd.h>

#endif



#ifdef __EMX__

#include <float.h>

#include <sys/uflags.h>

#endif



#include <octave/oct.h>

#include <octave/symtab.h>



#include <stdio.h>



#include "ls-octave.h"



#include "MatrixD.hpp"

#include "ExOctave.h"



/* Tip



You can extract the data from an Octave Matrix object using



  const double *d = val.matrix_value().data()



This returns all the elements in column-major order.



The Octave sources themselves contain lots of examples.  A good place

to start would be the files like src/svd.cc and liboctve/dbleSVD.cc.

*/



void test_list( void );

void globalize_table( symbol_table *st );

void test_symbol( void );



/* GLOBALS */

#define MAX_AKKU 10

static unsigned long akkus_used[] = {0,0,0,0,0,0,0,0,0,0};

Matrix Akku[MAX_AKKU];



static octave_value transfer_value;



void exOctavInit( void )

{

  ColumnVector y (3);

  RowVector x (3);

  ColumnVector z (3);

  Matrix m(1,1,1.0 ), n(2,2,3.5), o(4,4);



  printf("hallo octave \n");



test_list();

test_symbol();

}



void exOctavExit( void )

{

}



void test_list( void )

{

   octave_value       variable;

   octave_value_list  daten;

   char name_buf[] = "Var1";



   int i;

   for (i=0; i<10; i++)

      daten.resize ( daten.length()+1, Matrix(i+1,3,i) );



   ofstream datei ( "test.mat", ios::out|ios::trunc|ios::bin);

   ofstream sinus ( "sinusit.mat", ios::out|ios::trunc|ios::bin);

   for (i=0; i<daten.length(); i++)

   {

      // cout << daten(i).matrix_value() << endl;

      sprintf( name_buf, "Var%d", i );

      save_mat_data (datei, daten(i), name_buf );

   }

   save_mat_data(sinus, daten(3), "Var3" );

   sinus.close ();

   datei.close ();

}



void globalize_table( symbol_table *st )

{

   top_level_sym_tab = st;

   curr_sym_tab = st;

   global_sym_tab = st;

}



void test_symbol( void )

{

   int i;

   char name[256];

   symbol_table var_liste_senke;

   symbol_table var_liste_quelle;





   globalize_table( &var_liste_senke );



   for(i=1;i<=5;i++)

   {

     sprintf(name,"Var%d",i);

     set_global_value( name, octave_value( Matrix(i,i,i) ) );

   }



   for(i=1;i<=5;i++)

   {

     sprintf(name,"Var%d",i);

     // cout << get_global_value(name).matrix_value() << endl;

   }



   save_to_mat( "test1.mat" );

   var_liste_senke.clear (0);





   globalize_table( &var_liste_quelle );

   load_from_mat( "sinusit.mat" );

   Matrix nimm = get_global_value( "Var3" ).matrix_value();

   var_liste_quelle.clear (0);

}



/***************************************************************************

 ***************************************************************************

 *

 *  Classname:     OctaveIni

 *

 *  Documentation: Eine Matlab-Datei wird gelesen und ihr Inhalt in einer

 *                 Liste gespeichert. Die Methoden bieten Zugriff auf die

 *                 einzelnen Variablen.

 *

 *  History:       1. August 1998

 *

 *

 ***************************************************************************

 ***************************************************************************/



OctaveIni::OctaveIni( char * dateiname )

{

   symbol_table * var_liste_ini = (symbol_table *) new symbol_table;

   // globalize_table( var_liste_ini );

   var_liste = var_liste_ini;

   globalize_sym_tab ();

   load_from_mat ( dateiname );

}



OctaveIni::~OctaveIni( void )

{

   symbol_table * var_liste_ini = (symbol_table *) var_liste;

   var_liste_ini->clear (0);

   delete var_liste_ini;

}



void OctaveIni::globalize_sym_tab( void )

{

   symbol_table * st = (symbol_table *) var_liste;

   top_level_sym_tab = st;

   curr_sym_tab = st;

   global_sym_tab = st;

}



double OctaveIni::get_value( char * var_name )

{

   globalize_sym_tab ();

   Matrix get = get_global_value( var_name ).matrix_value();

   return get (0,0);

}



double OctaveIni::get_value( char * var_name, unsigned long x, unsigned long y )

{

   globalize_sym_tab ();

   Matrix get = get_global_value( var_name ).matrix_value();

   return get (x-1,y-1);

}



const char * OctaveIni::get_string( char * var_name )

{

   globalize_sym_tab ();

   return get_global_value( var_name ).all_strings()[0].c_str();

}



void OctaveIni::get_oct_value( char * var_name )

{

   globalize_sym_tab ();

   transfer_value = get_global_value( var_name );

}





/***************************************************************************

 ***************************************************************************

 *

 *  Classname:     OctaveVals

 *

 *  Documentation: 2D-Matritzen werden in einer Liste Verwaltet.

 *                 Die Methoden bieten Zugriff auf die einzelnen Variablen.

 *                 Die Variablen knnen in einer Matlab-Datei gespeichert werden.

 *

 *  History:       1. August 1998

 *

 *

 ***************************************************************************

 ***************************************************************************/



OctaveVals::OctaveVals( char * dateiname )

{

   symbol_table * var_liste_vals = (symbol_table *) new symbol_table;

   // globalize_table( var_liste_ini );

   var_liste = var_liste_vals;

   globalize_sym_tab ();

   strcpy( filename, dateiname );

   strcpy( pathname, "..\\Daten\\" );

   with_buffer = 0;

}



OctaveVals::OctaveVals( char * dateiname, unsigned long size_x, unsigned long size_y )

{

   symbol_table * var_liste_vals = (symbol_table *) new symbol_table;

   // globalize_table( var_liste_ini );

   var_liste = var_liste_vals;

   globalize_sym_tab ();



   strcpy( filename, dateiname );

   strcpy( pathname, "..\\Daten\\" );

   strcpy( buffer_name, "Buffer" );



   buf_size_x = size_x;

   buf_size_y = size_y;



   set_global_value( buffer_name, octave_value( Matrix( size_y, size_x, 0 ) ) );

   BufferMatrix = &( get_global_value( buffer_name ).matrix_value() );

   with_buffer = 1;

   // Matrix * BufMat = (Matrix *) new Matrix( size_y, size_x );

   // BufferMatrix = BufMat;

   Matrix2D * BufMat2D = (Matrix2D *) new Matrix2D( size_x, size_y, (double *) get_global_value( buffer_name ).matrix_value().data() );

   BufferMatrix2D = BufMat2D;

}



OctaveVals::~OctaveVals( void )

{

   symbol_table * var_liste_vals = (symbol_table *) var_liste;

   var_liste_vals->clear (0);

   delete var_liste_vals;

   if( with_buffer == 1 )

   {

      // Matrix * BufMat = (Matrix *) BufferMatrix;

      // delete BufMat;

      Matrix2D * BufMat2D = (Matrix2D *) BufferMatrix2D;

      delete BufMat2D;

   }

}



void OctaveVals::globalize_sym_tab( void )

{

   symbol_table * st = (symbol_table *) var_liste;

   top_level_sym_tab = st;

   curr_sym_tab = st;

   global_sym_tab = st;

}



const double * OctaveVals::create_matrix( char * var_name, unsigned long size_x, unsigned long size_y )

{

   const double * pArray;



   globalize_sym_tab ();

   set_global_value( var_name, octave_value( Matrix(size_y,size_x) ) );

   pArray = get_global_value( var_name ).matrix_value().data();



   return pArray;

}



const double * OctaveVals::create_akkum( char * var_name )

{

   const double * pArray;

   Matrix empty_buf(1,buf_size_x,0);



   strcpy( akku_name, var_name );

   globalize_sym_tab ();

   // set_global_value( akku_name, octave_value( Matrix(1,buf_size_x,0) ) );





   unsigned long i = 0;

   while( (akkus_used[i] != 0) && (i<MAX_AKKU) )

   {

      i++;

   }

   if( i < MAX_AKKU )

   {

      akkus_used[i] = 1;

      my_akku = i;

      Akku[my_akku] = empty_buf;

   }

   else

      printf("No more Akkus\n");



   pArray = Akku[my_akku].data();



   Matrix * pAkku = &Akku[my_akku];

   Akkumulator = pAkku;



   return pArray;

}



void OctaveVals::delete_akkum( void )

{

   Matrix none(1,1,0);

   globalize_sym_tab ();

   get_global_value( akku_name ).matrix_value() = none;

   Akku[my_akku] = none;

   akkus_used[my_akku] = 0;

}



void OctaveVals::close_akkum( void )

{

   Matrix none(1,1,0);

   globalize_sym_tab ();

   set_global_value( akku_name, octave_value( Akku[my_akku] ) );

   Akku[my_akku] = none;

   akkus_used[my_akku] = 0;

}



void OctaveVals::akkumulate( void )

{

   globalize_sym_tab ();

   Akku[my_akku] = Akku[my_akku].stack( get_global_value( buffer_name ).matrix_value() );

}



const double * OctaveVals::get_buffer( void )

{

   Matrix * BufMat = (Matrix *) BufferMatrix;

   return BufMat->data();

}



double ** OctaveVals::get_buffer_2D( void )

{

   Matrix2D * BufMat2D = (Matrix2D *) BufferMatrix2D;

   return BufMat2D->Array2D ();

}



void OctaveVals::print_buffer( void )

{

   Matrix2D * BufMat2D = (Matrix2D *) BufferMatrix2D;

   BufMat2D->Print ();

}



void OctaveVals::save_variables( OctaveIni * Ini, char ** var_name, int nvars )

{

   int i;



   for(i=0;i<nvars;i++)

      set_variable( Ini, var_name[i] );

}



void OctaveVals::set_variable( OctaveIni * INI, char * var_name )

{

   INI->get_oct_value(var_name);

   globalize_sym_tab ();

   set_global_value( var_name, transfer_value );

}



void OctaveVals::save( char * dateiname )

{

   char name[512];

   strcpy (name,pathname);



   globalize_sym_tab ();

   if( (strcmp(dateiname, "")==0) || (dateiname==NULL) )

   {

      strcat(name,filename);

   }

   else

   {

      strcat(name,dateiname);

   }

   save_to_mat( name );

}



void OctaveVals::set_data_path( char * pfadname )

{

   strcpy ( pathname, pfadname );

   printf("%s\n", pathname );

}









