#ifndef ExOctaveH
#define ExOctaveH
#endif

#if defined(__cplusplus)

class OctaveIni
{
   private:
      void * var_liste;
      void globalize_sym_tab( void );

   public:
      OctaveIni( char * dateiname );
      ~OctaveIni( void );
      APIRET Init( void );
      void get_oct_value( char * var_name );
      double get_value( char * var_name );
      double get_value( char * var_name, unsigned long x, unsigned long y );
      const char * get_string( char * var_name );

   public:
};

class OctaveVals
{
   private:
      void * var_liste;
      void globalize_sym_tab( void );
      void set_variable( OctaveIni * INI, char * var_name );
      char filename[256];
      char pathname[256];
      void * BufferMatrix;
      void * BufferMatrix2D;
      unsigned long buf_size_x;
      unsigned long buf_size_y;
      char buffer_name[256];
      char akku_name[256];
      BOOL with_buffer;
      void * Akkumulator;
      unsigned long my_akku;

   public:
      OctaveVals( char * dateiname );
      OctaveVals( char * dateiname, unsigned long size_x, unsigned long size_y );
      ~OctaveVals( void );
      const double * create_matrix( char * var_name, unsigned long size_x, unsigned long size_y );
      const double * create_akkum( char * var_name );
      void delete_akkum( void );
      void close_akkum( void );
      void akkumulate( void );
      const double * create_buffer( unsigned long size_x, unsigned long size_y );
      void save_matrix( char * var_name );
      void save_all( void );
      void copy_matrix( char * var_target, char * var_source, OctaveIni * source_table );
      const double * get_buffer( void );
      double ** get_buffer_2D( void );
      void print_buffer( void );
      void print_akku( void );
      void save( char * dateiname );
      void save_variables( OctaveIni * Ini, char ** var_name, int nvars );
      void set_data_path( char * pfadname );
};

#endif


/* PROTOTYPES */

#if defined(__cplusplus)
#define CLINK extern "C"
#else
#define CLINK extern
#endif

#ifdef _DLL
   #define EX _Export
#else
   #define EX
#endif

CLINK void EX exOctavInit( void );
CLINK void EX exOctavExit( void );


