#ifndef ExarWork

#define ExarWork

#endif



/* INCLUDES */



#include <stdlib.h>

#include <stdio.h>

#include <conio.h>

#include <math.h>

#include "Exar.h"

#include "ExarWork.hpp"

#include "ExarIsel.hpp"

#include "ExarProg.hpp"

#include "ExSorcus.hpp"

#include "ExarServ.h"

#include "MatrixD.hpp"

#include "ExOctave.h"



/* GLOBALS */



static OctaveIni * SysIni;

static OctaveIni * ExarIni;

static OctaveIni * ExarDB;

static Matrix2D * PufferMatrix;

static OctaveVals * Ergebnis;

static TYP * pPuffer;

static unsigned long puffer_zeilen, puffer_spalten;

static BOOL liste_offen = FALSE;


APIRET exFensterInit( Widget parent, GLOBALDAT *GlobDat )

{

   APIRET rc = 0;

   INIT_PARAM Init;

   static char string_buf[256];



   static int SchonMalDa = 0;

   /* Befehle werden nur dann bearbeitet, wenn Fenster zum ersten Mal Fokus erhlt */

   if ( SchonMalDa == 0 )

   {

      SysIni = (OctaveIni *) new OctaveIni ("\\exar\\daten\\exsysini.mat");

      ExarIni = (OctaveIni *) new OctaveIni ("\\exar\\daten\\exarini.mat");

      ExarDB = (OctaveIni *) new OctaveIni ("\\exar\\daten\\exardb.mat");



      Init.Nr = (ULONG) SysIni->get_value("ml2_nr");

      Init.Port = (ULONG) SysIni->get_value("ml2_adr");

      strcpy( string_buf, SysIni->get_string("ml2_os") );

      Init.os = string_buf;

      Init.modus = (ULONG) SysIni->get_value("ml2_mode");

      Init.irq = (ULONG) SysIni->get_value("ml2_irq");

      Init.dma = (ULONG) SysIni->get_value("ml2_dma");

      Init.rt_freq = (ULONG) SysIni->get_value("ml2_irq_freq");

      Init.pc_freq = (ULONG) Init.rt_freq>>3;

      Init.mit_int = (ULONG) SysIni->get_value("ml2_irq_with");

      Init.buf_zeilen = (ULONG) SysIni->get_value("mat_buf_rows");

      Init.buf_spalten = (ULONG) SysIni->get_value("mat_buf_channels");

      puffer_zeilen = Init.buf_zeilen;

      puffer_spalten = Init.buf_spalten;

      Init.svv_minus_90 = (ULONG) SysIni->get_value("svv_minus_90");

      Init.svv_plus_90 = (ULONG) SysIni->get_value("svv_plus_90");

      Init.svv_vertikal = (ULONG) SysIni->get_value("svv_vertikal");



      // PufferMatrix = (Matrix2D *) new Matrix2D( Init.buf_spalten, Init.buf_zeilen );

      // pPuffer = PufferMatrix->Array ();



      rc+= exSorcusInitAll( Init );



      delete SysIni;

      delete ExarIni;

      delete ExarDB;



      // rc += exSorcusInit();

      SchonMalDa = 1;

   }

   return rc;

}



void exMatrixPuffern( void )

{

   if( liste_offen )

      if( exPufferAustausch( pPuffer ) )

         Ergebnis->akkumulate ();

}







void exListeOeffnen( char * datei_name )

{

   if( !liste_offen )

   {

      liste_offen = TRUE;



      SysIni = (OctaveIni *) new OctaveIni ("\\exar\\daten\\exsysini.mat");

      ExarIni = (OctaveIni *) new OctaveIni ("\\exar\\daten\\exarini.mat");

      ExarDB = (OctaveIni *) new OctaveIni ("\\exar\\daten\\exardb.mat");



      Ergebnis = (OctaveVals *) new OctaveVals( (char *) ExarDB->get_string("OriginalFile"), puffer_spalten, puffer_zeilen );

      // Ergebnis->set_data_path( (char *)ExarDB->get_string("OriginalPath") );

      pPuffer = (double *) Ergebnis->get_buffer ();

   }

}



void exListeSpeichern( char * datei_name )

{

   static char *f_sys[] = { "SamplingRate", "svv_minus_90", "svv_plus_90", "svv_vertikal" };

   static char *f_ini[] = { "AcquisitionProgram", "Calibration", "DataNames", "DataUnits", "Examinator", "RecordingDevice" };

   static char *f_db[]  = { "Birthday", "Comment", "Date", "Diagnosis", "OriginalFile", "Subject" };



   if( liste_offen )

   {

      Ergebnis->save_variables( SysIni,  f_sys, 4 );

      Ergebnis->save_variables( ExarIni, f_ini, 6 );

      if( strcmp( datei_name, "calibration.mat" ) != 0 )

      {

         Ergebnis->save_variables( ExarDB,  f_db,  6 );

      }

      Ergebnis->save( datei_name );

      delete Ergebnis;



      delete SysIni;

      delete ExarIni;

      delete ExarDB;



      liste_offen = FALSE;

   }



}



void exMatrixOeffnen( char * var_name )

{

   if( liste_offen )

      Ergebnis->create_akkum( var_name );

}



void exMatrixSchliessen( char * var_name )

{

   if( liste_offen )

      Ergebnis->close_akkum();

}





