#include <fstream.h>

#include <iostream.h>



#include <float.h>

#include <stdlib.h>

#include <stdio.h>

#include <math.h>





#include "MatrixD.hpp"



/* Tip



You can extract the data from an Octave Matrix object using



  const double *d = val.matrix_value().data()



This returns all the elements in column-major order.



The Octave sources themselves contain lots of examples.  A good place

to start would be the files like src/svd.cc and liboctve/dbleSVD.cc.

*/



/***************************************************************************

 ***************************************************************************

 *

 *  Klassenname:   Matrix3D

 *

 *  Documentation: Klasse dient dem Anlegen und Manipulieren von 3D-Feldern.

 *

 *  History:       Fri Jul 31 15:49:28 1998

 *

 ***************************************************************************

 ***************************************************************************/



/* METHODEN */



Matrix3D::Matrix3D( ULONG size_x, ULONG size_y, ULONG size_z )

{

   dim.x = dim_x = size_x;

   dim.y = dim_y = size_y;

   dim.z = dim_z = size_z;



   dim_xyz = dim_x * dim_y * dim_z;



   pT = (TYP_P) malloc ( sizeof(TYP) * dim_xyz );



   pppT = (TYP_PPP) malloc ( sizeof(TYP_PP) * dim_z );

   for(i=0;i<dim_z;i++)

   {

      pppT[i] = (TYP_PP) malloc ( sizeof(TYP_P) * dim_y );

      for(j=0;j<dim_y;j++)

         pppT[i][j] = pT + i*dim_x*dim_y + j*dim_x;

   }

}



Matrix3D::~Matrix3D( void )

{

   for(i=0;i<dim_z;i++)

      free( pppT[i] );

   free( pppT );

   free( pT );

}



void Matrix3D::Print( void )

{

   for(i=0;i<dim_z;i++)

   {

      printf ("#Z=%d\n", i);

      for( j=0; j<dim_y; j++ )

      {

         printf ("|\t");

         for( k=0; k<dim_x; k++ )

            printf ("%f\t", pppT[i][j][k]);

         printf ("|\n");

      }

   }

}



void Matrix3D::Print( ULONG x, ULONG y, ULONG z )

{

   if( bounds_chk(x,y,z) )

      printf ("%f\n", pppT[z][y][x]);

   else

      printf ("\t[%d][%d][%d]\tExceeding Bounds\n",x,y,z);

}



/***************************************************************************

 ***************************************************************************

 *

 *  Klassenname:   Matrix2D

 *

 *  Documentation: Klasse dient dem Anlegen und Manipulieren von 2D-Feldern.

 *

 *  History:       Fri Jul 31 15:49:28 1998

 *

 ***************************************************************************

 ***************************************************************************/



/* METHODEN */



Matrix2D::Matrix2D( ULONG size_x, ULONG size_y )

{

   dim.x = dim_x = size_x;

   dim.y = dim_y = size_y;



   dim_xy = dim_x * dim_y;



   pT = (TYP_P) malloc ( sizeof(TYP) * dim_xy );

   free_field = TRUE;



   ppT = (TYP_PP) malloc ( sizeof(TYP_P) * dim_y );

   for(i=0;i<dim_y;i++)

   {

      ppT[i] = pT + i*dim_x;

   }

}



Matrix2D::Matrix2D( ULONG size_x, ULONG size_y, const TYP_P field )

{

   dim.x = dim_x = size_x;

   dim.y = dim_y = size_y;



   dim_xy = dim_x * dim_y;



   pT = (TYP_P) field;

   free_field = FALSE;



   ppT = (TYP_PP) malloc ( sizeof(TYP_P) * dim_y );

   for(i=0;i<dim_y;i++)

   {

      ppT[i] = pT + i*dim_x;

   }

}



Matrix2D::~Matrix2D( void )

{

   free( ppT );

   if( free_field ) free( pT );

}



void Matrix2D::Print( void )

{

      for( i=0; i<dim_y; i++ )

      {

         for( j=0; j<dim_x; j++ )

            printf ("%3.3f\t", ppT[i][j]);

         printf ("\n");

      }

}



void Matrix2D::Print( ULONG x, ULONG y )

{

   if( bounds_chk(x,y) )

      printf ("%3.3f\n", ppT[y][x]);

   else

      printf ("\t[%d][%d]\tExceeding Bounds\n",x,y);

}





