#ifndef MatrixDH

#define MatrixDH

#endif



typedef double TYP;

typedef TYP    * TYP_P;

typedef TYP_P  * TYP_PP;

typedef TYP_PP * TYP_PPP;



#if defined(__cplusplus)



typedef struct

{

   public:

      ULONG x;

      ULONG y;

      ULONG z;

} Matrix3Dim;



class Matrix3D

{

   private:

      TYP * pT;

      TYP ** ppT;

      TYP *** pppT;

      ULONG dim_x;

      ULONG dim_y;

      ULONG dim_z;

      ULONG dim_xyz;

      ULONG i, j, k;

      BOOL free_field;

      inline BOOL bounds_chk( ULONG x, ULONG y, ULONG z ) { return x<dim_x&&y<dim_y&&z<dim_z; }



   public:

      Matrix3D( ULONG size_x, ULONG size_y, ULONG size_z );

      ~Matrix3D( void );

      TYP *** Array3D( void ) { return pppT; }

      TYP *   Array( void ) { return pT; }

      void Set( TYP value ) { for(i=0;i<dim_xyz;i++) pT[i]=value; }

      void Set( void ) { for(i=0;i<dim_xyz;i++) pT[i]=i; }

      inline void Set( ULONG x, ULONG y, ULONG z, TYP value = 0 ) { if(bounds_chk(x,y,z)) pppT[z][y][x] = value; }

      inline TYP  Get( ULONG x, ULONG y, ULONG z ) { if(bounds_chk(x,y,z)) return pppT[z][y][x]; else return HUGE_VAL; }

      void Print( void );

      void Print( ULONG x, ULONG y, ULONG z );

      Matrix3Dim dim;

};



typedef struct

{

   public:

      ULONG x;

      ULONG y;

} Matrix2Dim;



class Matrix2D

{

   private:

      TYP * pT;

      TYP ** ppT;

      ULONG dim_x;

      ULONG dim_y;

      ULONG dim_xy;

      ULONG i, j;

      BOOL free_field;

      inline BOOL bounds_chk( ULONG x, ULONG y ) { return x<dim_x&&y<dim_y; }



   public:

      Matrix2D( ULONG size_x, ULONG size_y );

      Matrix2D( ULONG size_x, ULONG size_y, const TYP_P field );

      ~Matrix2D( void );

      TYP ** Array2D( void ) { return ppT; }

      TYP *   Array( void ) { return pT; }

      void Set( TYP value ) { for(i=0;i<dim_xy;i++) pT[i]=value; }

      void Set( void ) { for(i=0;i<dim_xy;i++) pT[i]=i; }

      inline void Set( ULONG x, ULONG y, TYP value = 0 ) { if(bounds_chk(x,y)) ppT[y][x] = value; }

      inline TYP  Get( ULONG x, ULONG y ) { if(bounds_chk(x,y)) return ppT[y][x]; else return HUGE_VAL; }

      void Print( void );

      void Print( ULONG x, ULONG y );

      Matrix2Dim dim;

};





#endif





/* PROTOTYPES */



#if defined(__cplusplus)

#define CLINK extern "C"

#else

#define CLINK extern

#endif



#ifdef _DLL

   #define EX _Export

#else

   #define EX

#endif



